(define-module (ui logs ajax)
    :use-module (alterator ajax)
    :use-module (alterator algo)
    :use-module (alterator woo)
    :export (init))

;;; Functions
(define (do-apply data)
  (form-update-value-list '("start" "size" "text" "range") data))

(define (do-update . args)
  (catch/message
    (lambda()
      (do-apply (apply woo-read-first "/logs" 
		       'start (form-value "start")
		       'size (form-value "size")
		       'name (form-value "name")
		       'language (form-value "language")
		       args)))))

(define (do-select)
  (do-apply (woo-read-first "/logs"
			    'name (form-value "name")
			    'language (form-value "language")
			    'last #t)))

(define (do-size)
  (do-update 'new_size (form-value "new_size")))

(define (do-back)
  (do-update 'back #t))

(define (do-next)
  (do-update 'next #t))

(define (do-first)
  (do-update 'first #t))

(define (do-last)
  (do-update 'last #t))

(define (on-load)
  (catch/message
    (lambda()
      (form-update-enum "new_size" (woo-list "/logs/avail_size" 'language (form-value "language")))
      (let* ((log-list (woo-list "/logs/avail_log" 'language (form-value "language")))
	     (log-first (or (cond-car log-list) (woo-error (_ "No logs available"))))
	     (log-name (woo-get-option log-first 'name))
	     (log-data (woo-read-first "/logs" 'last #t 'name log-name 'language (form-value "language"))))

	(form-update-enum "name" log-list)
	(form-update-value-list '("name" "new_size") log-data)
	(do-apply log-data))

      (form-bind "name" "change" do-select)
      (form-bind "new_size" "change" do-size)
      (form-bind "back_button" "click" do-back)
      (form-bind "next_button" "click" do-next)
      (form-bind "first_button" "click" do-first)
      (form-bind "last_button" "click" do-last))))
